//version march 1, 2024


// //\\ DOMContentLoaded **********************************
document.addEventListener( "DOMContentLoaded", function() {

//raw transcript
let transc = document.querySelector('.transc');

//=========================================
// //\\ RegEx goodies
//=========================================
//flag "u" : "unicode"
//"g"      : looks for all matches,
//multiple wholes
//matches, not multiple sub-matches"
//https://javascript.info/regexp-introduction
//https://stackoverflow.com/questions/19913667
// /javascript-regex-global-match-groups
//escape: https://javascript.info/regexp-escaping

var TIME_COLUMN =
    //ddd:ddd = catches time
    '( |\\t)*'
    + '(\\d+)'      //hour
    + ':(\\d+)'     //minute
    + '(:(\\d+))?'  //second
    ;
var TIME_HYPEN = TIME_COLUMN.replace( /:/gu, '-' );
var TIME_LINE =
    //start of a line
    '(^|\\n|\\r)';
    //start of query parameter
var TIME_QUERY = '((?:\\?|&)t=)';
//=========================================
// \\// RegEx goodies
//=========================================

//=========================================
// //\\ mode audio of video
//=========================================
{
    let a = document.querySelector('.fixed-bottom audio.the-media');
    let v = document.querySelector('.fixed-bottom video.the-media');
    let R = '((?:^\\?|^|&)m=(v|a))';
    let RR = new RegExp( R, 'u' );
    let q = window.location.search;
    let match = q.match( RR );
    if( a && v ) {
        if( match ) {
            if( match[2].toLowerCase()==='v' ) {
                a.style.display = 'none';
                a.setAttribute( 'class', 'disabled');
                v.style.display = 'in-line-block';
            } else {
                v.style.display = 'none';
                v.setAttribute( 'class', 'disabled');
                a.style.display = 'in-line-block';
            }
        } else if( a ) {
            ///default is "a", we do block v
            if( v ) {
                v.style.display = 'none';
                v.setAttribute( 'class', 'disabled');
            }
        }
    }
}
//=========================================
// \\// mode audio of video
//=========================================


//file:///home/pol/Documents/kwrap/kachur/petition/materials/audio-messages/2024/jan/10/transcript2.html?t=0-02-56
//=========================================
// //\\ main work
// //\\ anchorizes time offsets
//=========================================
var { newContent, hashedOffsets, prop, propS, inarray } = doParse({
    content : transc.innerHTML,
    separator : ':',
    liny:true
});
transc.innerHTML = newContent;
//=========================================
// \\// anchorizes time offsets
//=========================================

//=========================================
// //\\ positions transcript and media
//      from url-query
//=========================================
var extracted = query2time();
if( extracted !== null ) {
    let {
        newContent,
        //momentum
        prop, propS, inarray, totalSeconds
    } = extracted;
    if( prop !== null ) {
        ///attemps to set txt and audio to closest anchor hash
        var stopFlag = false;
        hashedOffsets.forEach( function(hashed, ix) {
            if( stopFlag ) return;
            if( hashed.totalSeconds >= totalSeconds ) {
                //stop, overrun
                if( hashed.totalSeconds !== totalSeconds ) {
                    ix = Math.max( 0,ix-1 );
                }
                let offs = hashedOffsets[ix];
                //big assumption: javascript flow does not restart
                window.location.hash = '#'+offs.prop;
                //does attempt to set to set media to the offset from query
                let media = document.querySelector('.fixed-bottom .the-media');
                media.currentTime = totalSeconds;
                stopFlag = true;
            }
        })
    }
}
//=========================================
// \\// positions transcript and media
//=========================================


//=========================================
// //\\ add anchors from editor notes
//=========================================
{
    let NOTE = TIME_LINE + '(\\[[^\\]]+\\])|(\\{([^\\}]+)\\})';
    let collectedAnchors = '';
    let tr = document.querySelector('.transc');
    let cont = tr.innerHTML;
    let RE  = new RegExp( NOTE, 'gu' );
    let count = 0;
    let newContent = cont.replace( RE, function(
            total,
            dummy,
            lineSquare,
            lineCurlyDumb,
            lineCurlySearched,
        ){
            let hash = 'c-'+count;
            count++;
            let theme = lineSquare || ('<b>' + lineCurlySearched + '</b>');
            collectedAnchors += '<a href="#'+hash+'">'+ theme + '</a>\n';
            ret = '\n<a name="' + hash + '"></a>' + theme;
            /*
            console.log(
            'total='+total,
            'dummy="'+dummy+'"',
            'lineSquare='+lineSquare,
            'lineCurlyDumb='+lineCurlyDumb,
            'lineCurlySearched='+lineCurlySearched,
            'ret='+ret);
            */
            return ret;
        });
        tr.innerHTML = newContent;
        let ath = document.querySelector('.author-thesises');
        ath.innerHTML += collectedAnchors;
    }
//=========================================
// \\// add anchors from editor notes
//=========================================



//=========================================
// //\\ adds open/closed book
//=========================================
    var divs = document.querySelectorAll( '.trigger-option' ).forEach( div =>
    {
        div.innerHTML = `
            <span class="isclosed" title="click to open local content">👇</span>
            <span class="isopen" title="click to close local content">👆</span>
        ` + div.innerHTML;
    });
    var divs = document.querySelectorAll( 'span.isclosed, span.isopen' ).forEach( div =>
    {
        div.addEventListener( 'click', clicker );
    });
    return;

    function clicker()
    {
        let p = this.parentNode.parentNode;
        p.className = p.className === 'isopen' ? 'isclosed' : 'isopen';
    }
//=========================================
// \\// adds open/closed book
//=========================================
//=========================================
// \\// main work
//=========================================
return;


function query2time()
{
    let q = window.location.search;
    if( !q ) return null;
    let extracted = doParse({
        content : q,
        separator : '-',
        liny : false,
    });
    return extracted;
}

function doParse({ content, separator, liny })
{
    var prop=null, propS, inarray, hashedOffsets=[];
    var Reg = liny ? TIME_LINE : TIME_QUERY;
    Reg    += separator === ':' ? TIME_COLUMN : TIME_HYPEN;
    var RE  = new RegExp( Reg, 'gu' );
    let newContent = content.replace( RE, extractTime );
    return {
             //accomulated
             newContent, hashedOffsets,
             //momentum
             prop, propS, inarray, totalSeconds
    };

    function extractTime(
                total,
                line,
                indent,
                hour,
                minute,
                second,
            ) {
            let extr = normalizesTime(
                    total,
                    line,
                    hour,
                    minute,
                    second,
            );
            prop = extr.prop;
            propS = extr.propS;
            inarray = extr.inarray;
            totalSeconds = extr.totalSeconds;
            hashedOffsets.push(extr);
            return extr.offWithHash;
    }
}

function normalizesTime(
        total,
        line,
        hour,
        minute,
        second,
    ){
        if( !second ) {
            second = minute;
            minute = hour;
            hour = 0;
        } else {
            second = second.substr( 1 );
        }
        hour=parseInt(hour);
        minute=parseInt(minute);
        second=parseInt(second);
        let totalSeconds = hour*3600+minute*60+second;
        let prop = 't-'+hour+'-'+minute+'-'+second;
        let propS = hour+':'+minute+':'+second;
        let inarray = [hour,minute,second ];
        let offWithHash = total + '<a name="' + prop + '"></a>';
        return { offWithHash, prop, propS, inarray, totalSeconds };
    }
});
// \\// DOMContentLoaded **********************************



// //\\ sets style **********************************
( function setsStyle() {
   let style = `
    body {
        font-family : arial,helvetica,san-serif;
    }
    body {
        width : 100%;
        padding : 0px;
        margin : 0px;
    }
    body > div {
        text-align : center;
    }
    a {
        text-decoration: none;
    }


    /* //|| ************* proofchecked ************* */
    .proofchecked {
        padding-left : 5px;
        padding-right : 5px;
        background-color:#f3f3f3;
    }
    div.proofchecked {
        width : 95%;
        padding-left : 2%;
        padding-right : 2%;
    }
    /* ||// ************* proofchecked ************* */

    div.author-thesises a {
        color:#bbbbff;
    }


    /* //|| ************* book ************* */
    body .trigger-content {
        white-space : pre-wrap;
    }
    body,
    body .trigger-content {
        font-size : 15px;
    }
    body .trigger-content,
    body .trigger-option {
        font-family:arial,helvetica,san-serif;
    }
    span.isopen,
    span.isclosed {
        cursor : pointer;
        padding : 3px;
        font : bold;
        font-size : 17px;
    }
    .isopen div.trigger-content {
        display:block;
    }
    .isclosed div.trigger-content {
        display:none;
        margin-left:5px;
        padding:5px;
    }
    .isopen span.isopen,
    .isclosed span.isclosed {
        display:inline;
    }
    .isclosed span.isopen,
    .isopen span.isclosed {
        display:none;
    }
    .trigger-content {
        padding-left:5px;
        padding-right:5px;
        text-align:left;
    }
    div.trigger-option {
        display : inline-block;
        white-space : normal;
    }
    /* ||// ************* book ************* */


/* //|| ************* pseudo inline styles ************* */
.transc {
    display : inline-block;
    padding:0px;
    margin-left : 5%;
    margin-right : 5%;
    width : 90%;
    max-width : 800px;
    text-align : left;
    white-space : pre-wrap;
}

.fluid-bottom {
    display : inline-block;
    width:100%;
    height:460px; /* guessing */
    padding : 0px;
    text-aligh : left;
}

.fixed-bottom {
    position:fixed;
    bottom:0px;
    width:100%;
    padding : 0px;
    text-aligh : left;
    z-index:1;
}

.sub-fixed-bottom {
    display : inline-block;
    padding:0px;
    margin-left : 5%;
    margin-right : 5%;
    border-top:20px solid #ffffff;
    width : 90%;
    max-width : 800px;
    text-align : center;
    background-color:#333333;
    color:#ffffff;
}

.media-caption {
    display : inline-block;
    float:left;
    padding:10px 5% 10px 5%;
    margin:0px;
    max-height:25px;
    overflow:auto;
    text-align : left;
    background-color:#333333;
    color:#ffffff;
}


.source-icons {
    display : inline-block;
    float:right;
    padding:10px 5% 10px 5%;
    margin:0px;
    max-height:25px;
    overflow:auto;
    text-align : left;
    background-color:#333333;
    color:#ffffff;
}

.author-thesises {
    max-height:200px;
    overflow:auto;
    padding:0px 5% 0px 5%;
    margin:0px;
    font-size:14px;
    white-space : pre-wrap;
    text-align : left;
    width : 90%;
    background-color:#333333;
    color:#ffffff;
}

.editor-notes {
    display:inline-block;
    font-size:16px;
    padding:0px 0% 0px 0%;
    margin:0px;
    width:90%;
    text-align : left;
    background-color:#33333;
    color:#ffffff;
}

.editor-notes-text {
    width:100%;
    padding:5px;
    background-color:#ffffff;
    color:#000000;"
}

.media-tags-placeholder {
    display:inline-block;
    width : 90%;
    margin-top : 5px;
    margin-bottom : 5px;
    text-align : center;
}
/* ||// ************* pseudo inline styles ************* */

`;
    let s = document.createElement( 'style' );
    s.innerHTML = style;
    document.head.appendChild( s );
})();
// \\// sets style **********************************

