//==================================================
// //\\ sets style
//==================================================
( function() {
   let style = `
    body {
        font-family : arial,helvetica,san-serif;
    }
    body {
        width : 100%;
        padding : 0px;
        margin : 0px;
    }
    body > div {
        text-align : center;
    }
    a {
        text-decoration: none;
    }


    /* //|| ************* proofchecked ************* */
    .proofchecked {
        padding-left : 5px;
        padding-right : 5px;
        background-color: rgba( 0,0,0,0.05);
    }
    div.proofchecked {
        width : 95%;
        padding-left : 2%;
        padding-right : 2%;
    }
    /* ||// ************* proofchecked ************* */

    a {
        color : #0000ff;
    }
    a:visited {
        color : #9900ee;
    }

    div.author-thesises a {
        color : #00ffff;
    }
    div.author-thesises a:visited {
        color : #ee0099;
    }
    .author-thesises {
        max-height:200px;
        overflow:auto;
        padding:0px 5% 0px 5%;
        margin:0px;
        font-size:14px;
        text-align : left;
        width : 90%;
        background-color:#333333;
        color:#ffffff;
    }


    /* //|| ************* book ************* */
    body.trigger-content {
        white-space : pre-wrap;
    }
    body,
    body .trigger-content {
        font-size : 15px;
    }
    body .trigger-content,
    body .trigger-option {
        font-family:arial,helvetica,san-serif;
    }
    span.isopen,
    span.isclosed {
        cursor : pointer;
        padding : 3px;
        font : bold;
        font-size : 17px;
    }
    .isopen div.trigger-content {
        display:block;
    }
    .isclosed div.trigger-content {
        display:none;
        margin-left:5px;
        padding:5px;
    }
    .isopen span.isopen,
    .isclosed span.isclosed {
        display:inline;
    }
    .isclosed span.isopen,
    .isopen span.isclosed {
        display:none;
    }
    .trigger-content {
        padding-left:5px;
        padding-right:5px;
        text-align:left;
    }
    div.trigger-option {
        display : inline-block;
        white-space : normal;
    }
    /* ||// ************* book ************* */

.div-time {
    display : inline-block;
    cursor : pointer;
    color : #005577;
}

.theme-pointer {
    cursor : pointer;
    color : #ccddff;
}

.theme-pointer.main {
    padding-top:8px;
}

.theme-stone {
    display:inline;
    cursor : pointer;
    color : #005577;
}
.theme-stone.dividor {
    display:block;
}


.highlighter {
    position : absolute;
    height : 60px;
    background-image: linear-gradient(to bottom, rgba(0,50,80,0), rgba(0,50,80,0.15) 30%, rgba(0,50,80,0.2) 50%, rgba(0,50,80,0.15) 70%, rgba(0,50,80,0) );
    z-index : -1;
}

/* //|| ************* pseudo inline styles ************* */
.transc {
    position : relative;
    display : inline-block;
    padding:0px;
    margin-left : 5%;
    margin-right : 5%;
    width : 90%;
    max-width : 800px;
    text-align : left;
    white-space : pre-wrap;
}

.fluid-bottom {
    display : inline-block;
    width:100%;
    height:500px; /* guessing */
    padding : 0px;
    text-aligh : left;
}

.fixed-bottom {
    position:fixed;
    bottom:0px;
    width:100%;
    padding : 0px;
    text-aligh : left;
    z-index:1;
}

.sub-fixed-bottom {
    display : inline-block;
    padding:0px;
    margin-left : 5%;
    margin-right : 5%;
    border-top:20px solid #ffffff;
    width : 90%;
    max-width : 800px;
    text-align : center;
    background-color:#333333;
    color:#ffffff;
}

.media-caption {
    display : inline-block;
    float:left;
    padding:10px 10px 10px 5%;
    margin:0px;
    max-height:35px;
    max-width:80%;
    overflow:auto;
    text-align : left;
    background-color:#333333;
    color:#ffffff;
}


.source-icons {
    display : inline-block;
    float:right;
    padding:10px 10px 10px 10px;
    margin:0px;
    max-height:25px;
    overflow:auto;
    text-align : left;
    background-color:#333333;
    color:#ffffff;
}

.editor-notes {
    display:inline-block;
    font-size:16px;
    padding:0px 0% 0px 0%;
    margin:0px;
    width:90%;
    text-align : left;
    background-color:#33333;
    color:#ffffff;
}

.editor-notes-text {
    width:100%;
    padding:5px;
    border-radius:5px;
    background-color:#ffffff;
    color:#000000;"
}

.media-tags-placeholder {
    display:inline-block;
    width : 90%;
    margin-top : 5px;
    margin-bottom : 5px;
    text-align : center;
}
/* ||// ************* pseudo inline styles ************* */

`;
    let s = document.createElement( 'style' );
    s.innerHTML = style;
    document.head.appendChild( s );
})();
//==================================================
// \\// sets style
//==================================================




//==================================================
// //\\ DOMContentLoaded
//==================================================
document.addEventListener( "DOMContentLoaded", function() {

//raw transcript
let transc = document.querySelector('.transc');



//==================================================
// //\\ parsing metadata, no name garbage leaked
//==================================================
{
let dataOriginal = document.querySelector('.data-original');
let dataCaption = dataOriginal.innerHTML;
let dataOriginalLink = dataOriginal.getAttribute( 'data-original-linkl' );
let dataContentsList = dataOriginal.getAttribute( 'data-path-to-contents-list' ) ||
                       '../index.html';

let dataThesises = document.querySelector('.data-thesises');

let dataAudio = document.querySelector('.data-audio');
let dataAudioType='';
let dataAudioFile='';
if( dataAudio ) {
    dataAudioType = dataAudio.getAttribute( 'data-audio-type' );
    dataAudioFile = dataAudio.getAttribute( 'data-audio-file' );
}

let dataVideo = document.querySelector('.data-video');
let dataVideoType='';
let dataVideoFile='';
if( dataVideo ) {
    dataVideoType = dataVideo.getAttribute( 'data-video-type' );
    dataVideoFile = dataVideo.getAttribute( 'data-video-file' );
}

if( !document.title && dataCaption ) {
    document.title = dataCaption;
}

let fixedFooter = `
        <!-- main conents of fixed -->
        <div class="sub-fixed-bottom">
            <div class="media-caption"><b>
                ${dataCaption}
            </b></div>
            <div class="source-icons">
                <a
                    target="__blank"
                    title="Пойти на Первоисточник"
                    style="color:#ddddff; font-size:20px;"
                    href="${dataOriginalLink}"
                >

                <b>☼</b></a>
                <a  title="Вернуться на заглавную страницу"
                    href="${dataContentsList}"><b>
                🏠</b></a>
            </div>
            <div class="author-thesises"><i>${dataThesises.innerHTML}</i>
</div>

            <div class="media-tags-placeholder">
`;

if( dataAudio && dataAudioFile ) {
    fixedFooter += `
<audio class="the-media" controls title="Сохранённая копия"
    style="width:100%;  max-height:200px; padding:0px;">
    <source type="${dataAudioType}" src="${dataAudioFile}">
</audio>
`; }

if( dataVideo && dataVideoFile ) {
    fixedFooter += `
<video class="the-media" controls title="Сохранённая копия"
    style="width:50%; max-height:200px; padding:0px;">
    <source ${dataVideoType}" src="${dataVideoFile}">
</video>
`; }

 fixedFooter += `
        </div>
            <div class="editor-notes">
                <div class="isclosed">
                    <div class="trigger-option">
                    </div>
                    <div class="trigger-content">
                        <div class="editor-notes-text">
                        ● - дословный текст, <br>
                        <span class="proofchecked">выверенный транскрипт помещён на сером фоне.</span><br>
                        [...], /.../, "○" - вставки редактора текста.<br>
                        курсив и жирный текст может быть от редактора,<br>
                        </div>
                    </div>
                </div>
            </div>
            <br><br>
        </div>
</div>
`;

dataOriginal.remove();
delete dataOriginal;
dataThesises.remove();
delete dataThesises;

if( dataAudio ) {
    dataAudio.remove();
    delete dataAudio;
}
if( dataVideo ) {
    dataVideo.remove();
    delete dataVideo;
}

let mainDiv = document.createElement( 'div' );
document.body.insertBefore( mainDiv, transc  );
let subMainDiv = document.createElement( 'div' );
mainDiv.appendChild( subMainDiv );
subMainDiv.appendChild( transc );

let fluidButtom = document.createElement( 'div' );
fluidButtom.setAttribute( 'class', 'fluid-bottom' );
mainDiv.parentNode.insertBefore(fluidButtom, mainDiv.nextSibling);

let fixedButtom = document.createElement( 'div' );
fixedButtom.setAttribute( 'class', 'fixed-bottom' );
fluidButtom.parentNode.insertBefore(fixedButtom, fluidButtom.nextSibling);

fixedButtom.innerHTML = fixedFooter;
//==================================================
// \\// parsing metadata, no name garbage leaked
//==================================================
}


//=========================================
// //\\ RegEx goodies
//=========================================
//flag "u" : "unicode"
//"g"      : looks for all matches,
//multiple wholes
//matches, not multiple sub-matches"
//https://javascript.info/regexp-introduction
//https://stackoverflow.com/questions/19913667
// /javascript-regex-global-match-groups
//escape: https://javascript.info/regexp-escaping

var TIME_COLUMN =
    //ddd:ddd = catches time
    '( |\\t)*'
    + '(\\d+)'      //hour
    + ':(\\d+)'     //minute
    + '(:(\\d+))?'  //second
    ;
var TIME_HYPEN = TIME_COLUMN.replace( /:/gu, '-' );
var TIME_LINE =
    //start of a line
    '(^|\\n)';
    //start of query parameter
var TIME_QUERY = '((?:\\?|&)t=)';
//=========================================
// \\// RegEx goodies
//=========================================

//=========================================
// //\\ mode audio of video
//      is first thing which is set,
//      if both tags do exist, then either
//      one can be elected from URL query
//=========================================
var media = null;
{
    let a = document.querySelector('.fixed-bottom audio');
    let v = document.querySelector('.fixed-bottom video');
    let R = '((?:^\\?|^|&)m=(v|a))';
    let RR = new RegExp( R, 'u' );
    let q = window.location.search;
    let match = q.match( RR );
    if( a && v ) {
        if( match ) {
            if( match[2].toLowerCase()==='v' ) {
                a.style.display = 'none';
                a.setAttribute( 'class', 'disabled');
                v.style.display = 'in-line-block';
                media = v;
            } else {
                v.style.display = 'none';
                v.setAttribute( 'class', 'disabled');
                a.style.display = 'in-line-block';
                media = a;
            }
        } else if( a ) {
            ///default is "a", we do block v
            media = a;
            if( v ) {
                v.style.display = 'none';
                v.setAttribute( 'class', 'disabled');
            }
        }
    } else if( a ) {
        media = a;
    } else if( v ) {
        media = v;
    }
}
//=========================================
// \\// mode audio of video
//=========================================


//=========================================
// //\\ main work
// //\\ anchorizes time offsets
//=========================================
var tagStones = [];
var { newContent, prop, propS, inarray } = doParse({
    content : transc.innerHTML,
    separator : ':',
    liny:true
});
transc.innerHTML = newContent;
var highlighter = document.createElement( 'div' );
highlighter.setAttribute( 'class', 'highlighter' );
if( !tagStones.length ) {
    ////transcript-stone-less mode
    highlighter.style.display = 'none';
}
//=========================================
// \\// anchorizes time offsets
//=========================================



//=========================================
// //\\ modifies tagstones in transcript div
///     and in contents dashboard
//=========================================
{
    let NOTE =
            //makes text dividor
            '(' + TIME_LINE + '(\\[[^\\]]+\\])|(\\{([^\\}]+)\\}))'
            //makes quote ++XXXXX--
            + '|(\\+\\+((?!--)(.|\n))+--)'
            ;
    let collectedAnchors = '';
    let cont             = transc.innerHTML;
    let RE               = new RegExp( NOTE, 'gu' );
    let count            = 0;
    let newContent = cont.replace( RE, function(
            total,
            dummy,
            dummy2,
            lineSquare,
            lineCurlyDumb,
            lineCurlySearched,
            lineQuote,
        ){
            let pointer = 'pointer-'+count;
            count++;
            //⬜ ○
            if( lineSquare ) {
                let ls = lineSquare;
                ls = ls.substr(1,ls.length-2);
                var themePointer = '○ '+ ls;
                var themeStone = '○ '+ ls;
                var cls = 'theme-pointer ';
            } else if( lineCurlySearched ) {
                let curl = lineCurlySearched;
                var themePointer = '\n● <b>' + curl + '</b>';
                var themeStone = '● <b>' + curl + '</b>';
                var cls = 'theme-pointer main ';
            } else {
                var quote = lineQuote.substr(2, lineQuote.length-4);
                var themePointer = '\n● ' + quote;
                var themeStone = quote;
                var cls = 'theme-pointer ';
            }
            collectedAnchors += '<div class="' + cls + pointer + '">'+
                                themePointer + '</div>';
            ret = '<div class="' +
                  (lineSquare ? 'dividor ' : '') +
                  'theme-stone ' +  pointer + '">' + themeStone + '</div>';
            return ret;
    });
    //***************************************
    //last one textual innerHTML modification
    transc.innerHTML = newContent;
    transc.appendChild( highlighter );
    //***************************************

    // //\\ restores physical tag stones
    tagStones.forEach( (ts, ix) => {
        ts.html = document.querySelector( '.dt-' + ix );
        ts.html.addEventListener( 'click', ev => {
            media.currentTime = ts.totalSeconds;
            media.play();
        });
    });
    // \\// restores physical tag stones
    let ath = document.querySelector(
              '.author-thesises .trigger-content.contents') ||
              document.querySelector('.author-thesises');
    ath.innerHTML += collectedAnchors;
    let themePointers = document.querySelectorAll( '.theme-pointer' );
    themePointers.forEach( (ttp, ix ) => {
            var fullCls = ttp.getAttribute( 'class' );
            var hash = fullCls.replace( /(theme-pointer main|theme-pointer)\s*/, '' );
            var selector = 'div.theme-stone.'+hash;
            var { timeOffset, toScroll, toScrollStripe } =
                  getTimeStone( selector );
            var themeStoneTag = document.querySelector( selector );
            ttp.addEventListener( 'click', ev => {
                media.currentTime = timeOffset;
                media.play();
            });
            themeStoneTag.addEventListener( 'click', ev => {
                media.currentTime = timeOffset;
                media.play();
            });
    });
}
//=========================================
// \\// modifies tagstones in transcript div
//=========================================



//=========================================
// //\\ adds open/closed book
//=========================================
var divs = document.querySelectorAll( '.trigger-option' ).forEach( div =>
{
    div.innerHTML = `
        <span class="isclosed" title="click to open local content">👇</span>
        <span class="isopen" title="click to close local content">👆</span>
    ` + div.innerHTML;
});
var divs = document.querySelectorAll( 'span.isclosed, span.isopen' ).forEach( div => {
    div.addEventListener( 'click', clicker );
});

media && media.addEventListener("timeupdate", function() {
    var { toScroll, toScrollStripe } = getTimeStone();
    highlighter.style.top = toScrollStripe.toFixed(2) + 'px';
    //todm width*0.99, it is not clear why this coefficient, needs work,
    highlighter.style.width = (transc.getBoundingClientRect().width*
                               0.99).toFixed(1) + 'px';
    //console.log( 'toScroll=' + toScroll.toFixed(1) );
    window.scrollTo(0,toScroll);
});
//=========================================
// \\// adds open/closed book
//=========================================


//=========================================
// //\\ positions transcript and media
//      from url-query
//=========================================
var extracted = query2time();
if( extracted !== null ) {
    let {
        newContent,
        //momentum
        prop, totalSeconds
    } = extracted;
    if( prop !== null ) {
        ///attemps to set txt and audio to closest anchor hash
        var stopFlag = false;
        tagStones.forEach( function(tSt, ix) {
            if( stopFlag ) return;
            if( tSt.totalSeconds >= totalSeconds ) {
                //stop, overrun
                if( tSt.totalSeconds !== totalSeconds ) {
                    ix = Math.max( 0,ix-1 );
                }
                //worked well: //window.location.hash = '#'+offs.prop;
                //does attempt to set to set media to the offset from query
                stopFlag = true;
            }
        });
        if( stopFlag ) {
            //console.log( 'query done '+totalSeconds );
            setTimeout( function() {
                //console.log( 'before timeout run' );
                media.currentTime = totalSeconds;

                //var { toScroll, toScrollStripe } = getTimeStone();
                //console.log( toScroll );
                //window.scrollTo(0,toScroll);
            }, 1000 ); //todo why?
        }
    }
}
//=========================================
// \\// positions transcript and media
// \\// main work
//=========================================
return;



///gets either from timeStone, or from
///media.currentTime,
function getTimeStone( timeStoneSelector )
{
    if( tagStones.length ) {
        var { fraction, ixBottom, ixTop, subOffset, timeOffset } =
                findsTimeTagStones( media.currentTime, timeStoneSelector );
    } else {
        ////protects against empty time stones in text-contents
        return { timeOffset:0, toScroll:0, toScrollStripe:0 };
    }

    let ixPrevious = Math.max(0, ixBottom-1);
    let ixCurrent = Math.max(0, ixBottom );
    let ixNext = ixTop;
    let sPrevious = 'div.dt-' + ixPrevious;
    let sCurrent = 'div.dt-' + ixCurrent;
    let sNext = 'div.dt-' + ixNext;

    let previosFrag = document.querySelector( sPrevious );
    let currentFrag = document.querySelector( sCurrent );
    let nextFrag = document.querySelector( sNext );
    if( !previosFrag || !currentFrag || !nextFrag ) return;

    let previosBox = previosFrag.getBoundingClientRect();
    let currentBox = currentFrag.getBoundingClientRect();
    let nextBox = nextFrag.getBoundingClientRect();
    let trBox = transc.getBoundingClientRect();

    //this did work, but was too dramatic, nearly reloading a page ...
    //big assumption: javascript flow does not restart
    //window.location.hash = '#'+previousOffs.prop;

    let currentHeight = nextBox.top - currentBox.bottom;
    var fragHeight = currentHeight * fraction-15;
    var toScroll = previosBox.top - trBox.top;
    var toScrollStripe = toScroll + fragHeight + currentBox.bottom - currentBox.top;
    if( ixPrevious !== ixCurrent ) {
        toScroll += fragHeight;
        var toScrollStripe = toScroll + currentBox.bottom - previosBox.top;
    }
    return { timeOffset, toScroll, toScrollStripe };
}



function findsTimeTagStones(
    timeOffset, //optional,
    timeStoneSelector //flag, optional alternative to timeOffset
){
    var stopFlag = false;
    var len1 = tagStones.length-1;
    var ixTop=len1;
    if( timeStoneSelector ) {
        var positioner = document.querySelector( timeStoneSelector );
        if( !positioner ) return { fraction:0, ixBottom:0, ixTop:0, subOffset:0 };
        var posTop = positioner.getBoundingClientRect().top;
    }
    tagStones.forEach( function(hashed, ix) {
        if( stopFlag ) return;
        if( positioner ) {
            var currentHashDiv = document.querySelector( '.dt-' + ix );
            var hashedTop = currentHashDiv.getBoundingClientRect().top;
            if( hashedTop && posTop <= hashedTop ) {
                ixTop = ix;
                stopFlag = true;
            }
        } else {
            if( timeOffset <= hashed.totalSeconds ) {
                ixTop = ix;
                stopFlag = true;
            }
        }
    });
    var ixBottom = Math.max( 0, ixTop-1 );
    var tgB = tagStones[ ixBottom ];
    let tgT = tagStones[ ixTop ];
    let botDiv = tgB.html;
    let topDiv = tgT.html;
    var bottom = tgB.totalSeconds;
    var top = tgT.totalSeconds;
    var dt = top - bottom;
    if( positioner ) {
        let botBot = botDiv.getBoundingClientRect().bottom;
        let topTop = topDiv.getBoundingClientRect().top;
        let height = Math.max( 1, topTop - botBot );
        let fractionMiddle = (posTop - botBot) / height;
        fractionMiddle = Math.min(1,Math.max(0,fractionMiddle));
        timeOffset = bottom + dt * fractionMiddle;
    }
    var subOffset = Math.max( 0, timeOffset - bottom );
    var fraction = dt === 0 ? 0 : Math.min( 1, subOffset/dt );
    return { fraction, ixBottom, ixTop, subOffset, timeOffset };
}

function clicker()
{
    let p = this.parentNode.parentNode;
    p.className = p.className === 'isopen' ? 'isclosed' : 'isopen';
}



function query2time()
{
    let q = window.location.search;
    if( !q ) return null;
    let extracted = doParse({
        content : q,
        separator : '-',
        liny : false,
    });
    return extracted;
}

function doParse({ content, separator, liny })
{
    var prop = null, propS, inarray, totalSeconds;
    var Reg  = liny ? TIME_LINE : TIME_QUERY;
    Reg     += separator === ':' ? TIME_COLUMN : TIME_HYPEN;
    var RE   = new RegExp( Reg, 'gu' );

    let newContent = content.replace( RE, extractTime );
    return {
             //accomulated
             newContent,
             //last replacement momentum data:
             prop, propS, inarray, totalSeconds
    };

    function extractTime(
        total,
        line,
        indent,
        hour,
        minute,
        second,
    ) {
        let extr = normalizesTime(
            total,
            line,
            hour,
            minute,
            second,
        );
        prop = extr.prop;
        propS = extr.propS;
        inarray = extr.inarray;
        totalSeconds = extr.totalSeconds;
        liny && tagStones.push(extr);
        return extr.offWithHash;
    }
}

function normalizesTime(
        total,
        line,
        hour,
        minute,
        second,
    ){
        if( !second ) {
            second = minute;
            minute = hour;
            hour = 0;
        } else {
            second = second.substr( 1 );
        }
        hour=parseInt(hour);
        minute=parseInt(minute);
        second=parseInt(second);
        let totalSeconds = hour*3600+minute*60+second;
        let prop = 't-'+hour+'-'+minute+'-'+second;
        let propS = hour+':'+minute+':'+second;
        let inarray = [hour,minute,second ];

        let pureTotal = total.replace( '\n', '' );
        //was: let offWithHash = total + '<a name="' + prop + '"></a>';
        //this array is used only when parsing content's text, this array
        //is not used when parsing URL-query-string,
        let cls = ' class="div-time ' + prop + ' dt-' + tagStones.length + '"';
        let offWithHash = '\n<div' + cls + '>' + pureTotal + '</div>';
        return { offWithHash, prop, propS, inarray, totalSeconds };
    }
});
//==================================================
// \\// DOMContentLoaded
//==================================================


